Subject: Can rs_cindex be < 0 for bitmap heap scans?

From: Melanie Plageman <[email-masked]>
Date: Wed, 23 Oct 2024 18:15:37 -0400

Hi,

HeapScanDescData->rs_cindex (the current index into the array of
visible tuples stored in the heap scan descriptor) is used for
multiple scan types, but for bitmap heap scans, AFAICT, it should
never be < 0.

As such, I find this test in heapam_scan_bitmap_next_tuple() pretty confusing.

 if (hscan->rs_cindex < 0 || hscan->rs_cindex >= hscan->rs_ntuples)

I know it seems innocuous, but I find it pretty distracting. Am I
missing something? Could it somehow be < 0?

If not, I propose removing that part of the if statement like in the
attached patch.

- Melanie